## mingw-w64-python3.13-3.13.7-4.src.tar.zst

=== Tools/peg_generator/Makefile ===
UNAME_S := $(shell uname -s)
ifeq ($(UNAME_S),Linux)
	PYTHON ?= ../../python
endif
ifeq ($(UNAME_S),Darwin)
	PYTHON ?= ../../python.exe
endif
VENVDIR ?= ./venv
VENVPYTHON ?= $(VENVDIR)/bin/python
CPYTHON ?= ../../Lib
MYPY ?= ./venv/bin/mypy
BLACK ?= ./venv/bin/black

GRAMMAR = ../../Grammar/python.gram
TOKENS = ../../Grammar/Tokens

build: peg_extension/parse.c

peg_extension/parse.c: $(GRAMMAR) $(TOKENS) pegen/*.py peg_extension/peg_extension.c ../../Parser/pegen.c ../../Parser/pegen_errors.c ../../Parser/string_parser.c ../../Parser/action_helpers.c ../../Parser/*.h pegen/grammar_parser.py
	$(VENVPYTHON) -m pegen -q c $(GRAMMAR) $(TOKENS) -o peg_extension/parse.c --compile-extension

clean:
	-rm -f peg_extension/*.o peg_extension/*.so peg_extension/parse.c
	-rm -rf $(VENVDIR)

regen-metaparser: pegen/metagrammar.gram pegen/*.py
	$(VENVPYTHON) -m pegen -q python pegen/metagrammar.gram -o pegen/grammar_parser.py

# Note: These targets really depend on the generated shared object in peg_extension/parse.*.so but
# this has different names in different systems so we are abusing the implicit dependency on
# parse.c by the use of --compile-extension.

venv:
	$(PYTHON) -m venv $(VENVDIR)
	$(VENVPYTHON) -m pip install -U pip setuptools black mypy
	@echo "The venv has been created in the $(VENVDIR) directory"

mypy: regen-metaparser
	$(MYPY)  # For list of files, see mypy.ini

format-python:
	$(BLACK) pegen

format: venv format-python

tags: TAGS

TAGS: pegen/*.py test/test_pegen.py
	etags pegen/*.py test/test_pegen.py

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# Maintainer: Ray Donnelly <mingw.android@gmail.com>
# Maintainer: Naveen M K <naveen521kk@gmail.com>
# Contributor: Saul Ibarra Corretge <saghul@gmail.com>
# Contributor: Frode Solheim <frode@fs-uae.net>

_primary_python="no"
_pybasever=3.13
_realname=python

if [[ "${_primary_python}" == "yes" ]]; then
  pkgbase="mingw-w64-${_realname}"
  pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
  provides=("${MINGW_PACKAGE_PREFIX}-python3"
            "${MINGW_PACKAGE_PREFIX}-python${_pybasever}")
  conflicts=("${MINGW_PACKAGE_PREFIX}-python3"
             "${MINGW_PACKAGE_PREFIX}-python${_pybasever}"
            "${MINGW_PACKAGE_PREFIX}-python2<2.7.16-7")
  replaces=("${MINGW_PACKAGE_PREFIX}-python3"
            "${MINGW_PACKAGE_PREFIX}-python${_pybasever}")
else
  pkgbase="mingw-w64-${_realname}${_pybasever}"
  pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}${_pybasever}")
fi
pkgver=${_pybasever}.7
pkgrel=4
pkgdesc="A high-level scripting language (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
license=('spdx:PSF-2.0')
url="https://www.python.org/"
msys2_repository_url="https://github.com/python/cpython"
msys2_references=(
  "cpe: cpe:/a:python:python"
  "cpe: cpe:/a:python_software_foundation:python"
)
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-bzip2"
         "${MINGW_PACKAGE_PREFIX}-libffi"
         "${MINGW_PACKAGE_PREFIX}-mpdecimal"
         "${MINGW_PACKAGE_PREFIX}-ncurses"
         "${MINGW_PACKAGE_PREFIX}-openssl"
         "${MINGW_PACKAGE_PREFIX}-sqlite3"
         "${MINGW_PACKAGE_PREFIX}-tcl"
         "${MINGW_PACKAGE_PREFIX}-tk"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-libb2"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-tzdata")
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-autotools"
  "autoconf-archive"
)
#options=('debug' '!strip')
source=("https://www.python.org/ftp/python/${pkgver%rc?}/Python-${pkgver}.tar.xz"
        "EXTERNALLY-MANAGED"
        0001-sysconfig-make-_sysconfigdata.py-relocatable.patch
        0002-build-add-with-nt-threads-and-make-it-default-on-min.patch
        0003-Define-MS_WINDOWS-and-others-when-compiling-with-MIN.patch
        0004-configure-add-MACHDEP-and-platform-on-MINGW.patch
        0005-Add-default-configuration-for-MINGW.patch
        0006-configure-enable-largefile-support-by-default-for-Mi.patch
        0007-Add-PC-to-CPPFLAGS-and-to-SRCDIRS-on-Mingw.patch
        0008-posixmodule.c-Define-necessary-headers-for-compiling.patch
        0009-Build-winreg-by-default-when-compiling-for-MINGW.patch
        0010-exports.h-Add-support-for-MINGW.patch
        0011-configure-add-options-so-that-shared-build-is-possib.patch
        0012-Add-dynamic-loading-support-for-MINGW.patch
        0013-Ignore-main-program-for-frozen-scripts-on-MINGW.patch
        0014-Detect-winsock2-and-setup-_socket-module-on-MINGW.patch
        0015-Enable-some-windows-specific-modules.patch
        0016-sysconfig-MINGW-build-extensions-with-GCC.patch
        0017-sysconfig-treat-MINGW-builds-as-POSIX-builds.patch
        0018-Add-support-for-stdcall-without-underscore.patch
        0019-Customize-site-for-MINGW.patch
        0020-add-python-config-sh.patch
        0021-mingw-prefer-unix-sep-if-MSYSTEM-environment-variabl.patch
        0022-msys-cygwin-semi-native-build-sysconfig.patch
        0023-sysconfig-mingw-sysconfig-like-posix.patch
        0024-mingw-use-backslashes-in-compileall-py.patch
        0025-mingw-pdcurses_ISPAD.patch
        0026-remove_path_max.default.patch
        0027-dont-link-with-gettext.patch
        0028-ctypes-python-dll.patch
        0029-gdbm-module-includes.patch
        0030-use-gnu_printf-in-format.patch
        0031-mingw-fix-ssl-dont-use-enum_certificates.patch
        0032-fix-using-dllhandle-and-winver-mingw.patch
        0033-Add-AMD64-to-sys-config-so-msvccompiler-get_build_ve.patch
        0034-MINGW-link-with-additional-library.patch
        0035-install-msilib.patch
        0036-fix-signal-module-build.patch
        0037-build-build-winconsoleio-and-_testconsole.patch
        0038-expose-sem_unlink.patch
        0039-Use-cygpty-while-using-isatty.patch
        0040-build-link-win-resource-files-and-build-pythonw.patch
        0041-fix-isselectable.patch
        0042-configure.ac-fix-inet_pton-check.patch
        0043-pass-gen-profile-ldflags.patch
        0044-pkg-config-windows-must-link-ext-with-python-lib.patch
        0045-importlib-bootstrap-path-sep.patch
        0046-warnings-fixes.patch
        0047-fix-build-testinternalcapi.patch
        0048-clang-arm64.patch
        0049-configure.ac-set-MINGW-stack-reserve.patch
        0050-Don-t-use-os.pathsep-to-find-EOF-not-all-distributio.patch
        0051-Fix-extension-suffix-for-c-extensions-on-mingw.patch
        0052-Change-the-get_platform-method-in-sysconfig.patch
        0053-tests-fix-test_bytes.patch
        0054-time-fix-strftime-not-raising-for-invalid-year-value.patch
        0055-ctypes-find_library-c-should-return-None-with-ucrt.patch
        0056-build-Disable-checks-for-dlopen-dlfcn.patch
        0057-Fix-install-location-of-the-import-library.patch
        0058-build-Integrate-venvlauncher-build-installation-into.patch
        0059-configure.ac-set-_WIN32_WINNT-version.patch
        0060-configure.ac-don-t-check-for-clock_-functions.patch
        0061-expanduser-normpath-paths-coming-from-env-vars.patch
        0062-CI-test-the-build-and-add-some-mingw-specific-tests.patch
        0063-Define-PY3_DLLNAME-to-fix-build.patch
        0064-_testconsole.c-Fix-casing-path-sep.patch
        0065-Return-consistent-architecture-markers-for-python-on.patch
        0066-mingw_smoketests-fix-_UCRT-condition.patch
        0067-Modify-sys.winver-to-match-upstream.patch
        0068-Change-user-site-packages-path-to-include-the-enviro.patch
        0069-configure-Include-a-header-in-the-check-for-_beginth.patch
        0070-configure.ac-Default-to-without-c-locale-coercion-on.patch
        0071-Fix-failing-tests.patch
        0072-Don-t-change-os.sep-with-an-empty-MSYSTEM-env-var-no.patch
        0073-def-VPATH-when-compiling-Python-sysmodule.c.patch
        0074-Make-_Py_CheckPython3-extern.patch
        0075-link-with-bcrypt.patch
        0076-correctly-find-native-python.patch
        0077-Add-extra-flags-for-_bootstrap_python.patch
        0078-posixmodule-undefine-HAVE_OPENDIR.patch
        0079-getpath.py-add-support-for-mingw.patch
        0080-Don-t-build-_posixsubprocess-on-Windows.patch
        0081-_ssl-link-with-ws2_32.patch
        0082-Always-normalize-path-in-abspath.patch
        0083-Include-winsock.h-when-checking-for-netdb-function.patch
        0084-include-_multiprocessing-semaphore.c-on-win32.patch
        0085-configure-build-mmap-module-on-win32.patch
        0086-venv-creation-fixes.patch
        0087-move-the-shutdown-function-where-winsock.h-is-includ.patch
        0088-configure.ac-set-BUILDEXEEXT-and-EXEEXT.patch
        0089-configure.ac-fix-building-some-test-modules.patch
        0090-Don-t-convert-sysconfig.get_config_var-VPATH-to-an-a.patch
        0091-Always-convert-to-before-passing-though-pathcch-func.patch
        0092-Build-venvlauncher.exe-from-PC-launcher.c.patch
        0093-getpath.py-fix-dirname.patch
        0094-getpath-use-normpath-on-all-generated-paths.patch
        0095-pathconfig-normpath-sys.path-0.patch
        0096-smoketests-add-some-tests-for-sys-site-paths.patch
        0097-Search-DLLs-only-on-paths-added-using-add_dll_direct.patch
        0098-Build-and-install-libpython3.dll.patch
        0099-Port-GetPythonImport-to-mingw.patch
        0100-LoadLibraryExW-make-sure-to-only-use-backslashes-for.patch
        0101-mingw_smoketests-add-a-test-to-check-if-sysconfig-re.patch
        0102-Add-missing-library-for-multiprocessing-module.patch
        0103-selectmodule-add-support-for-MINGW.patch
        0104-readline-disable-on-MINGW.patch
        0105-Add-libraries-to-fix-compile-of-ctypes-on-MINGW.patch
        0106-Enable-_uuid-on-MINGW.patch
        0107-Enable-curses-library-on-MINGW.patch
        0108-mingw_smoketests-disable-distutils-related-tests.patch
        0109-configure.ac-use-autoconf-2.69.patch
        0110-CI-clean-up-ignored-tests.patch
        0111-gcc-make-incompatible-pointer-types-as-warning.patch
        0112-test_makefile-normalize-path.patch
        0113-sysconfig.get_platform-use-consistent-naming.patch
        0114-Add-ucrt-to-version-string.patch
        0115-socketmodule-fix-captilization-of-headers.patch
        0116-mingw_smoketests-build-extension-in-a-venv.patch
        0117-venvlauncher-try-looking-for-the-versioned-.exe-firs.patch
        0118-Remove-_POSIX_BUILD-variable.patch
        0119-Add-MINGW-to-version-string.patch
        0120-There-are-no-more-MSI-module.patch
        0121-Disable-__try-__except-for-MINGW.patch
        0122-Add-missing-function-declaration-for-smoke-testing.patch
        0123-Try-fix-venv-setup.patch
        0124-Declare-timeval-for-MINGW.patch
        0125-Fix-format-warning.patch
        0126-Fix-DEBUG-build.-Add-_d-suffix-for-lib-and-modules-e.patch
        0127-Add-ABIFLAGS-to-targets-when-needed-required-for-DEB.patch
        0128-sysconfig-Revert-changes-to-NT-schemes.-Mingw-use-Po.patch
        0129-Fix-python-names-in-smoketests.patch
        0130-Launcher-Skip-find-python-in-Registry-for-mingw-buil.patch
        0131-Fix-pragma-warnings.patch
        0132-ssl-module-Build-with-windows-cert-store-support.-Re.patch
        0133-Fix-variable-size-warning.patch
        0134-Mimic-MSVC-for-timezone-optimized-memcpy-for-hash-ma.patch
        0135-Fix-windows-cert-store-import-in-pythonfiles.patch
        0136-Fix-module-name.patch
        0137-Smoketests-Try-fix-build-extension.patch
        0138-Try-fix-LDFLAGS-passing-via-environment.patch
        0139-Fix-test-for-library-name.patch
        0140-GCC-macro-only-available-for-C-code.patch
        0141-sysconfig-Fix-test-for-mingw.patch
        0142-Makefile-Remove-duplicate-object-from-link.patch
        0143-Fix-compile-warnings.patch
        0144-Try-fix-SOABI-for-mingw-to-match-C-sources.patch
        0145-winreg-Cleanup-build-module.patch
        0146-smoketests-Adjust-SOABI-change.patch
        0147-Fix-timeval-declaration.patch
        0148-dictobject-Calculate-as-MSVC.patch
        0149-Fix-export-Py_GetBuildInfo-symbol.patch
        0150-Allow-profile-tests-failure.patch
        0151-ntpath-Try-fix-concatenate-UNC-paths.patch
        0152-Revert-fix-warning-for-semaphore.patch
        0153-Try-fix-build-C-modules.-Add-WMI-module.-Fix-SOABI-g.patch
        0154-Fix-format-identifier.patch
        0155-Try-fix-building-C-modules-for-Python.-Fixes-for-WMI.patch
        0156-Pass-profile-LDFLAGS-for-C-modules.patch
        0157-Fix-WMI-module-naming.patch
        0158-Install-venv-launchers-with-its-names.patch
        0159-Cleanup-USE_WIN32_MODULE-in-configure.patch
        0160-Update-iscygpty-from-upstream.-Cleanup-changes.patch
        0161-Fix-include-naming-for-cross-build.patch
        0162-Fix-exports-for-_suggestions-module.patch
        0163-sys-module-Implement-flags-is_mingw-and-use_alt_sep.patch
        0164-ntpath-Resolve-cyclic-dependency-with-os-module.patch
        0165-Fix-warning-in-soamphore-module.patch
        0166-smoketests-Use-new-flag-use_alt_sep.patch
        0167-_boostrap_external-Use-new-flag-use_alt_sep.patch
        0168-compileall-Normalize-paths.patch
        0169-Fix-fail-tests.patch
        0170-Revert-fix-warnings-for-semaphore.patch
        0171-Add-more-broken-tests.patch
        0172-Add-flag-for-64-bit-time-in-configure-script.patch
        0173-Try-fix-64-bit-time-support-for-32-bit-build-again.patch
        0174-Do-ne-sys-module-flags-underscored.patch
